#include <stdlib.h>
#include <stdio.h>
#include <mkl.h>

/* Main program */
int main() {
  //N, SELECTはユーザーが指定する
  int N = 4; //次元
  int NSELECT = 3; //何モード分計算するか
  //INPUT matrix A, Bもユーザーが指定する
  //対称行列のみ扱える、右上三角部分は0でうめる
  double a[N*N];
  a[0] = 0.24;   a[1] = 0.0;   a[2] = 0.0;    a[3] = 0.0;
  a[4] = 0.39;   a[5] = -0.11; a[6] = 0.0;    a[7] = 0.0;
  a[8] = 0.42;   a[9] = 0.79;  a[10] = -0.25; a[11] = 0.0;
  a[12] = -0.16; a[13] = 0.63; a[14] = 0.48;  a[15] = -0.03;
  double b[N*N];
  b[0] = 4.16;   b[1] = 0.0;   b[2] = 0.0;   b[3] = 0.0;
  b[4] = -3.12;  b[5] = 5.03;  b[6] = 0.0;   b[7] = 0.0;
  b[8] = 0.56;   b[9] = -0.83; b[10] = 0.76; b[11] = 0.0;
  b[12] = -0.10; b[13] = 1.09; b[14] = 0.34; b[15] = 1.18;

  int i,j;
  MKL_INT type = 1;
  int LDA = N;
  int LDB = N;
  int LDZ = N;
  int n = N;
  int il, iu, m, lda = LDA, ldz = LDZ, info, lwork;
  int ldb = LDB;
  double abstol, vl, vu;
  double wkopt;
  double* work;

  /* iwork dimension should be at least 5*n */
  int iwork[5*N], ifail[N];
  double w[N], z[LDZ*NSELECT];

  /* Executable statements */
  //printf( " DSYGVX Example Program Results\n" );
  /* Negative abstol means using the default value */
  abstol = -1.0;
  /* Set il, iu to compute NSELECT smallest eigenvalues */
  il = 1;
  iu = NSELECT;

  /* Query and allocate the optimal workspace */
  lwork = -1;
  dsygvx(&type, "Vectors", "Indices", "Upper", &n, a, &lda, b, &ldb, &vl, &vu, &il, &iu,
	  &abstol, &m, w, z, &ldz, &wkopt, &lwork, iwork, ifail, &info );
  lwork = (int)wkopt;
  work = (double*)malloc( lwork*sizeof(double) );
  /* Solve eigenproblem */
  dsygvx(&type, "Vectors", "Indices", "Upper", &n, a, &lda, b, &ldb, &vl, &vu, &il, &iu,
	  &abstol, &m, w, z, &ldz, work, &lwork, iwork, ifail, &info );

  //結果出力
  for(i=il-1;i<iu;i++){
    printf("%d mode eigenvalue... %e\n",i+1,w[i]);
  }
  printf("\n");
  for(i=il-1;i<iu;i++){
    printf("%d mode eigenvector\n",i+1);
    for(j=0;j<N;j++){
      printf("%e\n",z[j+i*N]);
    }
    printf("\n");
  }

  
 /* Free workspace */
  free( (void*)work );
  exit( 0 );
}
